searchData={"items":[{"type":"module","title":"DotenvyGenerators.Generator","doc":"Modified from `Mix.Generator`\nConveniences for working with paths and generating content.","ref":"DotenvyGenerators.Generator.html"},{"type":"function","title":"DotenvyGenerators.Generator.copy_file/3","doc":"Copies `source` to `target`.\n\nIf `target` already exists and the contents are not the same,\nit asks for user confirmation.","ref":"DotenvyGenerators.Generator.html#copy_file/3"},{"type":"function","title":"Options - DotenvyGenerators.Generator.copy_file/3","doc":"* `:force` - forces copying without a shell prompt\n  * `:quiet` - does not log command output","ref":"DotenvyGenerators.Generator.html#copy_file/3-options"},{"type":"function","title":"Examples - DotenvyGenerators.Generator.copy_file/3","doc":"iex> Mix.Generator.copy_file(\"source/gitignore\", \".gitignore\")\n    * creating .gitignore\n    true","ref":"DotenvyGenerators.Generator.html#copy_file/3-examples"},{"type":"function","title":"DotenvyGenerators.Generator.copy_template/4","doc":"Evaluates and copy templates at `source` to `target`.\n\nThe template in `source` is evaluated with the given `assigns`.\n\nIf `target` already exists and the contents are not the same,\nit asks for user confirmation.","ref":"DotenvyGenerators.Generator.html#copy_template/4"},{"type":"function","title":"Options - DotenvyGenerators.Generator.copy_template/4","doc":"* `:force` - forces copying without a shell prompt\n  * `:quiet` - does not log command output","ref":"DotenvyGenerators.Generator.html#copy_template/4-options"},{"type":"function","title":"Examples - DotenvyGenerators.Generator.copy_template/4","doc":"iex> assigns = [project_path: \"/Users/joe/newproject\"]\n    iex> Mix.Generator.copy_template(\"source/gitignore\", \".gitignore\", assigns)\n    * creating .gitignore\n    true","ref":"DotenvyGenerators.Generator.html#copy_template/4-examples"},{"type":"function","title":"DotenvyGenerators.Generator.create_directory/2","doc":"Creates a directory if one does not exist yet.\n\nThis function does nothing if the given directory already exists; in this\ncase, it still logs the directory creation.","ref":"DotenvyGenerators.Generator.html#create_directory/2"},{"type":"function","title":"Options - DotenvyGenerators.Generator.create_directory/2","doc":"* `:quiet` - does not log command output","ref":"DotenvyGenerators.Generator.html#create_directory/2-options"},{"type":"function","title":"Examples - DotenvyGenerators.Generator.create_directory/2","doc":"iex> Mix.Generator.create_directory(\"path/to/dir\")\n    * creating path/to/dir\n    true","ref":"DotenvyGenerators.Generator.html#create_directory/2-examples"},{"type":"function","title":"DotenvyGenerators.Generator.create_file/3","doc":"Creates a file with the given contents.\n\nIf the file already exists and the contents are not the same,\nit asks for user confirmation.","ref":"DotenvyGenerators.Generator.html#create_file/3"},{"type":"function","title":"Options - DotenvyGenerators.Generator.create_file/3","doc":"* `:force` - forces creation without a shell prompt\n  * `:quiet` - does not log command output","ref":"DotenvyGenerators.Generator.html#create_file/3-options"},{"type":"function","title":"Examples - DotenvyGenerators.Generator.create_file/3","doc":"iex> Mix.Generator.create_file(\".gitignore\", \"_build\\ndeps\\n\")\n    * creating .gitignore\n    true","ref":"DotenvyGenerators.Generator.html#create_file/3-examples"},{"type":"macro","title":"DotenvyGenerators.Generator.embed_template/2","doc":"Embeds a template given by `contents` into the current module.\n\nIt will define a private function with the `name` followed by\n`_template` that expects assigns as arguments.\n\nThis function must be invoked passing a keyword list.\nEach key in the keyword list can be accessed in the\ntemplate using the `@` macro.\n\nFor more information, check `EEx.SmartEngine`.","ref":"DotenvyGenerators.Generator.html#embed_template/2"},{"type":"macro","title":"Examples - DotenvyGenerators.Generator.embed_template/2","doc":"defmodule Mix.Tasks.MyTask do\n      require Mix.Generator\n      Mix.Generator.embed_template(:log, \"Log: <%= @log %>\")\n    end","ref":"DotenvyGenerators.Generator.html#embed_template/2-examples"},{"type":"macro","title":"DotenvyGenerators.Generator.embed_text/2","doc":"Embeds a text given by `contents` into the current module.\n\nIt will define a private function with the `name` followed by\n`_text` that expects no arguments.","ref":"DotenvyGenerators.Generator.html#embed_text/2"},{"type":"macro","title":"Examples - DotenvyGenerators.Generator.embed_text/2","doc":"defmodule Mix.Tasks.MyTask do\n      require Mix.Generator\n      Mix.Generator.embed_text(:error, \"There was an error!\")\n    end","ref":"DotenvyGenerators.Generator.html#embed_text/2-examples"},{"type":"function","title":"DotenvyGenerators.Generator.overwrite?/1","doc":"Prompts the user to overwrite the file if it exists.\n\nReturns false if the file exists and the user forbade\nto override it. Returns true otherwise.","ref":"DotenvyGenerators.Generator.html#overwrite?/1"},{"type":"function","title":"DotenvyGenerators.Generator.overwrite?/2","doc":"Prompts the user to overwrite the file if it exists.\n\nThe contents are compared to avoid asking the user to\noverride if the contents did not change. Returns false\nif the file exists and the content is the same or the\nuser forbade to override it. Returns true otherwise.","ref":"DotenvyGenerators.Generator.html#overwrite?/2"},{"type":"task","title":"mix dot.new","doc":"Creates a new Elixir project using Dotenvy for configuration.\nIt expects the path of the project as argument.\n\n    mix new PATH [--app APP] [--module MODULE] [--sup] [--umbrella]\n\nA project at the given PATH will be created. The\napplication name and module name will be retrieved\nfrom the path, unless `--module` or `--app` is given.\n\nAn `--app` option can be given in order to\nname the OTP application for the project.\n\nA `--module` option can be given in order\nto name the modules in the generated code skeleton.\n\nA `--sup` option can be given to generate an OTP application\nskeleton including a supervision tree. Normally an app is\ngenerated without a supervisor and without the app callback.\n\nAn `--umbrella` option can be given to generate an\numbrella project.","ref":"Mix.Tasks.Dot.New.html"},{"type":"task","title":"Examples - mix dot.new","doc":"mix dot.new hello_world\n\nIs equivalent to:\n\n    mix dot.new hello_world --module HelloWorld\n\nTo generate an app with a supervision tree and an application callback:\n\n    mix dot.new hello_world --sup\n\nTo generate an umbrella application with sub applications:\n\n    mix dot.new hello_world --umbrella\n    cd hello_world/apps\n    mix new child_app","ref":"Mix.Tasks.Dot.New.html#module-examples"},{"type":"function","title":"Mix.Tasks.Dot.New.reserved_application_names/0","doc":"Returns a list of reserved application names.","ref":"Mix.Tasks.Dot.New.html#reserved_application_names/0"},{"type":"task","title":"mix phx.new","doc":"Creates a new Phoenix project using `Dotenvy` for configuration.\n\nIt expects the path of the project as an argument.\n\n    $ mix phx.new PATH [--module MODULE] [--app APP]\n\nA project at the given PATH will be created. The\napplication name and module name will be retrieved\nfrom the path, unless `--module` or `--app` is given.","ref":"Mix.Tasks.Phx.New.html"},{"type":"task","title":"Options - mix phx.new","doc":"* `--umbrella` - generate an umbrella project,\n    with one application for your domain, and\n    a second application for the web interface.\n\n  * `--app` - the name of the OTP application\n\n  * `--module` - the name of the base module in\n    the generated skeleton\n\n  * `--database` - specify the database adapter for Ecto. One of:\n\n      * `postgres` - via https://github.com/elixir-ecto/postgrex\n      * `mysql` - via https://github.com/elixir-ecto/myxql\n      * `mssql` - via https://github.com/livehelpnow/tds\n      * `sqlite3` - via https://github.com/elixir-sqlite/ecto_sqlite3\n\n    Please check the driver docs for more information\n    and requirements. Defaults to \"postgres\".\n\n  * `--adapter` - specify the http adapter. One of:\n      * `cowboy` - via https://github.com/elixir-plug/plug_cowboy\n      * `bandit` - via https://github.com/mtrudel/bandit\n\n    Please check the adapter docs for more information\n    and requirements. Defaults to \"bandit\".\n\n  * `--no-assets` - equivalent to `--no-esbuild` and `--no-tailwind`\n\n  * `--no-dashboard` - do not include Phoenix.LiveDashboard\n\n  * `--no-ecto` - do not generate Ecto files\n\n  * `--no-esbuild` - do not include esbuild dependencies and assets.\n    We do not recommend setting this option, unless for API only\n    applications, as doing so requires you to manually add and\n    track JavaScript dependencies\n\n  * `--no-gettext` - do not generate gettext files\n\n  * `--no-html` - do not generate HTML views\n\n  * `--no-live` - comment out LiveView socket setup in your Endpoint\n    and assets/js/app.js. Automatically disabled if --no-html is given\n\n  * `--no-mailer` - do not generate Swoosh mailer files\n\n  * `--no-tailwind` - do not include tailwind dependencies and assets.\n    The generated markup will still include Tailwind CSS classes, those\n    are left-in as reference for the subsequent styling of your layout\n    and components\n\n  * `--binary-id` - use `binary_id` as primary key type in Ecto schemas\n\n  * `--verbose` - use verbose output\n\n  * `-v`, `--version` - prints the Phoenix installer version\n\nWhen passing the `--no-ecto` flag, Phoenix generators such as\n`phx.gen.html`, `phx.gen.json`, `phx.gen.live`, and `phx.gen.context`\nmay no longer work as expected as they generate context files that rely\non Ecto for the database access. In those cases, you can pass the\n`--no-context` flag to generate most of the HTML and JSON files\nbut skip the context, allowing you to fill in the blanks as desired.\n\nSimilarly, if `--no-html` is given, the files generated by\n`phx.gen.html` will no longer work, as important HTML components\nwill be missing.","ref":"Mix.Tasks.Phx.New.html#module-options"},{"type":"task","title":"Installation - mix phx.new","doc":"`mix phx.new` by default prompts you to fetch and install your\ndependencies. You can enable this behaviour by passing the\n`--install` flag or disable it with the `--no-install` flag.","ref":"Mix.Tasks.Phx.New.html#module-installation"},{"type":"task","title":"Examples - mix phx.new","doc":"$ mix phx.new hello_world\n\nIs equivalent to:\n\n    $ mix phx.new hello_world --module HelloWorld\n\nOr without the HTML and JS bits (useful for APIs):\n\n    $ mix phx.new ~/Workspace/hello_world --no-html --no-assets\n\nAs an umbrella:\n\n    $ mix phx.new hello --umbrella\n\nWould generate the following directory structure and modules:\n\n```text\nhello_umbrella/   Hello.Umbrella\n  apps/\n    hello/        Hello\n    hello_web/    HelloWeb\n```\n\nYou can read more about umbrella projects using the\nofficial [Elixir guide](https://hexdocs.pm/elixir/dependencies-and-umbrella-projects.html#umbrella-projects)","ref":"Mix.Tasks.Phx.New.html#module-examples"},{"type":"task","title":"mix phx.new.ecto","doc":"Creates a new Ecto project within an umbrella project.\n\nThis task is intended to create a bare Ecto project without\nweb integration, which serves as a core application of your\ndomain for web applications and your greater umbrella\nplatform to integrate with.\n\nIt expects the name of the project as an argument.\n\n    $ cd my_umbrella/apps\n    $ mix phx.new.ecto APP [--module MODULE] [--app APP]\n\nA project at the given APP directory will be created. The\napplication name and module name will be retrieved\nfrom the application name, unless `--module` or `--app` is given.","ref":"Mix.Tasks.Phx.New.Ecto.html"},{"type":"task","title":"Options - mix phx.new.ecto","doc":"* `--app` - the name of the OTP application\n\n  * `--module` - the name of the base module in\n    the generated skeleton\n\n  * `--database` - specify the database adapter for Ecto. One of:\n\n      * `postgres` - via https://github.com/elixir-ecto/postgrex\n      * `mysql` - via https://github.com/elixir-ecto/myxql\n      * `mssql` - via https://github.com/livehelpnow/tds\n      * `sqlite3` - via https://github.com/elixir-sqlite/ecto_sqlite3\n\n    Please check the driver docs for more information\n    and requirements. Defaults to \"postgres\".\n\n  * `--binary-id` - use `binary_id` as primary key type\n    in Ecto schemas","ref":"Mix.Tasks.Phx.New.Ecto.html#module-options"},{"type":"task","title":"Examples - mix phx.new.ecto","doc":"$ mix phx.new.ecto hello_ecto\n\nIs equivalent to:\n\n    $ mix phx.new.ecto hello_ecto --module HelloEcto","ref":"Mix.Tasks.Phx.New.Ecto.html#module-examples"},{"type":"task","title":"mix phx.new.web","doc":"Creates a new Phoenix web project within an umbrella project.\n\nIt expects the name of the OTP app as the first argument and\nfor the command to be run inside your umbrella application's\napps directory:\n\n    $ cd my_umbrella/apps\n    $ mix phx.new.web APP [--module MODULE] [--app APP]\n\nThis task is intended to create a bare Phoenix project without\ndatabase integration, which interfaces with your greater\numbrella application(s).","ref":"Mix.Tasks.Phx.New.Web.html"},{"type":"task","title":"Examples - mix phx.new.web","doc":"$ mix phx.new.web hello_web\n\nIs equivalent to:\n\n    $ mix phx.new.web hello_web --module HelloWeb\n\nSupports the same options as the `phx.new` task.\nSee `Mix.Tasks.Phx.New` for details.","ref":"Mix.Tasks.Phx.New.Web.html#module-examples"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"v0.9.0 - Changelog","doc":"Initial release. Version number matches corresponding version of `Dotenvy`. Includes tasks:\n\n- `dot.new`\n- `phx.new.ecto`\n- `phx.new`\n- `phx.new.web`","ref":"changelog.html#v0-9-0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}